<?php

defined( 'ABSPATH' ) || exit; //Exit if accessed directly

/**
 * This class will assign a course to optin prospects if the Learndash plugin is installed and free course is setup to assign
 * Class WFFN_Optin_Action_AffiliateWP_Lead
 */

if ( class_exists( 'Affiliate_WP' ) && ! class_exists( 'WFFN_Optin_Integration_AffiliateWP' ) ) {
	#[AllowDynamicProperties]

class WFFN_Optin_Integration_AffiliateWP extends Affiliate_WP_Base {

		private static $ins = null;
		public $context = 'BuildWooFunnels';
		public $referral_type = 'opt-in';

		/**
		 * WFFN_Optin_Integration_AffiliateWP constructor.
		 */
		public function __construct() {
			// Extend AffiliateWP Integration.
			add_filter( 'affwp_extended_integrations', [ $this, 'extend_affiliate_wp' ], 1 );
		}

		public static function get_instance() {
			if ( null === self::$ins ) {
				self::$ins = new self;
			}

			return self::$ins;
		}

		public function extend_affiliate_wp( $integrations ) {
			$integrations['buildwoofunnels'] = array(
				'name'     => 'BuildWooFunnels',
				'class'    => 'WFFN_Optin_Integration_AffiliateWP',
				'file'     => '../integrations/class-wffn-optin-integration-affiliatewp.php',
				'enabled'  => true,
				'supports' => array(), // Only enable sales reporting if your plugin will actually support sales data methods in the base class!
			);

			return $integrations;
		}

	}
}